`timescale 1ns / 1ps

// o̓t@C̎w

`define SOURCE_FILE "./lena.bmp"
`define DESTINATION_FILE "./lena_dest.bmp"

module testbench;
	parameter STEP = 100;	// NbN
	
	// S` D` ͂ꂼ2561sNZ̉ff[^
	// S`͓̓f[^AD`͏o̓f[^
	reg [7:0] S00, S01, S02, S03, S04, S05, S06, S07;
	reg [7:0] S08, S09, S10, S11, S12, S13, S14, S15;
	reg [7:0] S16, S17, S18, S19, S20, S21, S22, S23;
	reg [7:0] S24, S25, S26, S27, S28, S29, S30, S31;
	wire [7:0] D00, D01, D02, D03, D04, D05, D06, D07;
	wire [7:0] D08, D09, D10, D11, D12, D13, D14, D15;
	wire [7:0] D16, D17, D18, D19, D20, D21, D22, D23;
	wire [7:0] D24, D25, D26, D27, D28, D29, D30, D31;
	
	integer F_SOURCE, F_DEST;	// t@C|C^
	reg signed [7:0] INPUT_LINE_NUMBER, OUTPUT_LINE_NUMBER;	// ̍sԍ
	integer I;
	
	reg [7:0] HEADER [0:53];	// wb_p̈
	
	reg CLK, RESET, IN;
	wire OUT;
	
	FILTER CUT (
		.S00(S00),	.S01(S01),	.S02(S02),	.S03(S03),
		.S04(S04),	.S05(S05),	.S06(S06),	.S07(S07),
		.S08(S08),	.S09(S09),	.S10(S10),	.S11(S11),
		.S12(S12),	.S13(S13),	.S14(S14),	.S15(S15),
		.S16(S16),	.S17(S17),	.S18(S18),	.S19(S19),
		.S20(S20),	.S21(S21),	.S22(S22),	.S23(S23),
		.S24(S24),	.S25(S25),	.S26(S26),	.S27(S27),
		.S28(S28),	.S29(S29),	.S30(S30),	.S31(S31),
		.D00(D00),	.D01(D01),	.D02(D02),	.D03(D03),
		.D04(D04),	.D05(D05),	.D06(D06),	.D07(D07),
		.D08(D08),	.D09(D09),	.D10(D10),	.D11(D11),
		.D12(D12),	.D13(D13),	.D14(D14),	.D15(D15),
		.D16(D16),	.D17(D17),	.D18(D18),	.D19(D19),
		.D20(D20),	.D21(D21),	.D22(D22),	.D23(D23),
		.D24(D24),	.D25(D25),	.D26(D26),	.D27(D27),
		.D28(D28),	.D29(D29),	.D30(D30),	.D31(D31),
		.CLK(CLK), .RESET(RESET), .IN(IN),
		.ROW(INPUT_LINE_NUMBER[4:0]), .OUT(OUT));
	
	initial begin	// NbNWFl[^
		CLK <= 0;
		#(STEP*3/5)
		forever #(STEP/2)
			CLK <= ~CLK;
	end
	
	initial begin
		
		// ̓t@C̃I[v
		F_SOURCE = $fopen(`SOURCE_FILE, "rb");
		if(!F_SOURCE) begin
			$display("File open error (source).\n");
			$stop;
		end
		
		// wb_̓ǂݍ
		for(I=0; I<54; I=I+1) begin
			HEADER[I] = $fgetc(F_SOURCE);
		end
		
		// T|[gt@CłȂȂI
		// 32x32 bmp ` (24rbg, k),
		if (HEADER[0] != 8'h42 || HEADER[1] != 8'h4d ||
				{HEADER[21], HEADER[20], HEADER[19], HEADER[18]} != 32 ||
				{HEADER[25], HEADER[24], HEADER[23], HEADER[22]} != 32 ||
				HEADER[28] != 8'h18 || HEADER[30] != 8'h00) begin
			$display("Not supported file.\n");
			$fclose(F_SOURCE);
			$stop;
		end
		
		// o̓t@C̃I[v
		F_DEST = $fopen(`DESTINATION_FILE, "wb");
		
		if(!F_DEST) begin
			$display("File open error (destination).\n");
			$fclose(F_SOURCE);
			$stop;
		end
		
		// wb_̏o
		HEADER[2] = 8'h36;
		for(I=0; I<54; I=I+1) begin
			$fwrite (F_DEST, "%c", HEADER[I]);
		end
		
		INPUT_LINE_NUMBER = -1;
		OUTPUT_LINE_NUMBER = 0;
		
		IN = 0;
		
		// Zbg
		
		RESET <= 1;	
		
		#(STEP * 3)	RESET <= 0;
		#(STEP * 2);
		
		while(OUTPUT_LINE_NUMBER < 32) begin
				// S32so͂܂ 𑱂
			#STEP;
			
			if(INPUT_LINE_NUMBER < 31) begin
					// ̓f[^cĂƂ1sǂݍ
				
				if(INPUT_LINE_NUMBER == -1) begin	// 0sڏ IN  1 
					IN = 1;
				end
				
				INPUT_LINE_NUMBER = INPUT_LINE_NUMBER + 1;
				
				read_source_file(S00);	read_source_file(S01);
				read_source_file(S02);	read_source_file(S03);
				read_source_file(S04);	read_source_file(S05);
				read_source_file(S06);	read_source_file(S07);
				read_source_file(S08);	read_source_file(S09);
				read_source_file(S10);	read_source_file(S11);
				read_source_file(S12);	read_source_file(S13);
				read_source_file(S14);	read_source_file(S15);
				read_source_file(S16);	read_source_file(S17);
				read_source_file(S18);	read_source_file(S19);
				read_source_file(S20);	read_source_file(S21);
				read_source_file(S22);	read_source_file(S23);
				read_source_file(S24);	read_source_file(S25);
				read_source_file(S26);	read_source_file(S27);
				read_source_file(S28);	read_source_file(S29);
				read_source_file(S30);	read_source_file(S31);
			end else begin
				IN =  0;	// ̓f[^o͂ĂȂƂ IN  0 
			end
			
			// FILTER f[^o͂ĂƂAt@Co͂
			
			if(OUT) begin
				OUTPUT_LINE_NUMBER = OUTPUT_LINE_NUMBER + 1;
				
				write_dest_file(D00);	write_dest_file(D01);
				write_dest_file(D02);	write_dest_file(D03);
				write_dest_file(D04);	write_dest_file(D05);
				write_dest_file(D06);	write_dest_file(D07);
				write_dest_file(D08);	write_dest_file(D09);
				write_dest_file(D10);	write_dest_file(D11);
				write_dest_file(D12);	write_dest_file(D13);
				write_dest_file(D14);	write_dest_file(D15);
				write_dest_file(D16);	write_dest_file(D17);
				write_dest_file(D18);	write_dest_file(D19);
				write_dest_file(D20);	write_dest_file(D21);
				write_dest_file(D22);	write_dest_file(D23);
				write_dest_file(D24);	write_dest_file(D25);
				write_dest_file(D26);	write_dest_file(D27);
				write_dest_file(D28);	write_dest_file(D29);
				write_dest_file(D30);	write_dest_file(D31);
			end
		end	// while [v̏I
		
		// IAt@CăV~[VI
		
		# STEP
		
		$fclose(F_SOURCE);
		$fclose(F_DEST);
		
		$stop;
	end
	
	// ȉA^XN`
	
	// RGB e1sNZt@Cǂݍ݁A̕ϒlԂ
	task read_source_file;
		output [7:0] DATA;
		integer c;
		begin
			c = $fgetc(F_SOURCE);
			c = c + $fgetc(F_SOURCE);
			c = c + $fgetc(F_SOURCE);
			c = c / 3;
			DATA = c;
		end
	endtask
	
	// 1sNZ̋Pxl RGB 3lƂāAv3񏑂o
	task write_dest_file;
		input [7:0] DATA;
		integer c;
		begin
			c = DATA;
			$fwrite (F_DEST, "%c", c);
			$fwrite (F_DEST, "%c", c);
			$fwrite (F_DEST, "%c", c);
		end
	endtask
endmodule
